<?php
 /**
  * Plugin Name: WP SEO Tracker
 * Plugin URI: http://www.wpseotracker.com
 * Description: Tracks Important SEO Metrics like on-page elements, off-site links, google page rank, alexa rank and more for all website posts and pages. 
 * Version: 1.0
 * Author: WP SEO Tracker
 * Author URI: http://www.wpseotracker.com
 */

include('inc/simple_html_dom.php');
include('inc/pageranks.php');
 
function str_replace_first($search, $replace, $subject) {
    return implode($replace, explode($search, $subject, 2));
}

function GetBetween($content,$start,$end)
{
    $r = explode($start, $content);
    if (isset($r[1])){
        $r = explode($end, $r[1]);
        return $r[0];
    }
    return '';
}


function stk_file_get_contents_curl($url) {
    $ch = curl_init();

    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);

    $data = curl_exec($ch);
    curl_close($ch);

    return $data;
}


function stk_get_a_href($url){
					$url = htmlentities(strip_tags($url));
				   $ExplodeUrlInArray = explode('/',$url);
					$DomainName = $ExplodeUrlInArray[2];
					$file = @file_get_contents($url);
					$h1count = preg_match_all('/(href=["|\'])(.*?)(["|\'])/i',$file,$patterns);
					$linksInArray = $patterns[2];
					$CountOfLinks = count($linksInArray);
					$InternalLinkCount = 0;
					$ExternalLinkCount = 0;
					for($Counter=0;$Counter<$CountOfLinks;$Counter++) {
			
						if($linksInArray[$Counter] == "" || $linksInArray[$Counter] == "#")
							continue;
							 preg_match('/javascript:/', $linksInArray[$Counter],$CheckJavascriptLink);
						if($CheckJavascriptLink != NULL)
							continue;
							$Link = $linksInArray[$Counter];
						 preg_match('/\?/', $linksInArray[$Counter],$CheckForArgumentsInUrl);
						if($CheckForArgumentsInUrl != NULL)
						{
							$ExplodeLink = explode('?',$linksInArray[$Counter]);
							$Link = $ExplodeLink[0];
						}
						preg_match('/'.$DomainName.'/',$Link,$Check);
						if($Check == NULL)
						{
							preg_match('/http:\/\//',$Link,$ExternalLinkCheck);
							if($ExternalLinkCheck == NULL)
							{
								$InternalDomainsInArray[$InternalLinkCount] = $Link;
								$InternalLinkCount++;
							}
							else
							{
								$ExternalDomainsInArray[$ExternalLinkCount] = $Link;
								$ExternalLinkCount++;
							}
					
						}
						else
						{
							$InternalDomainsInArray[$InternalLinkCount] = $Link;
							$InternalLinkCount++;
						}
				}
			
				$LinksResultsInArray = array(
				'ExternalLinks'=>$ExternalDomainsInArray,
				'InternalLinks'=>$InternalDomainsInArray
				);
				return $LinksResultsInArray;
}


function stk_get_domain($url){
  $pieces = parse_url($url);
  $domain = isset($pieces['host']) ? $pieces['host'] : '';
  if (preg_match('/(?P<domain>[a-z0-9][a-z0-9\-]{1,63}\.[a-z\.]{2,6})$/i', $domain, $regs)) {
    return $regs['domain'];
  }
  return false;
}


add_action('admin_head', 'stk_custom_fonts');

function stk_custom_fonts() {
  echo '<style>
	   #wpbody h2 { font-size:30px; }
        tablex.form-table {
		max-width: 475px;
		float: left;
		margin-top: -14px;
		}
 	   tablex.form-table input[type="text"] {
		width: 350px;
		height: 33px;
	   }
	   tablex.form-table > tbody > tr > th {
		padding: 25px 0px 20px 0;

	   }
	   
	   table.BlueTable tbody tr.Even { background-color:#ffffff; }
	   
	   p.submit {padding:0;
		margin-top: 30px;
        }
	   .BlueTable { margin:20px;}
         #wpbody-content > form {
		margin: 20px 30px 0 10px;
	    }

  </style><script>
jQuery.noConflict();
jQuery(function() {
	jQuery("#stk_pages, #stk_posts").change(function(){
	 	var selVal = jQuery(this).find(":selected").data("url")
	 	jQuery("#stk_text_field_url").val(selVal);
	});
});
</script>';
  
  }
add_action( 'admin_menu', 'stk_add_admin_menu' );
function stk_add_admin_menu(  ) { 
	add_menu_page( 'Seo Tracker', 'Seo Tracker', 'manage_options', 'seo_tracker', 'seo_tracker_options_page' );

}

add_action( 'admin_init', 'stk_settings_init' );
function stk_settings_init(  ) { 
	if( false == get_option( 'stk_settings' ) ) { 
		$stk_settings_arr = array('stk_text_field_url'=>'');
		
		add_option( 'stk_settings', $stk_settings_arr );
	}
}


//********************options_page***********************
 
function seo_tracker_options_page() { 
	$tableoutput ='<form action="" method="post" class="wrap">
		<h2>WP SEO Tracker</h2>';

if( isset($_POST['stk_text_field_url']) && $_POST['stk_text_field_url'] !='' ) {
	$optionsx = get_option( 'stk_settings' );
	$nwky = $optionsx['stk_text_field_act_key'];
	$stk_text_field_url  = trim($_POST['stk_text_field_url']);
	$stk_settings_arr = array('stk_text_field_url'=>$stk_text_field_url);
		
	 update_option( 'stk_settings', $stk_settings_arr );

}
  
		$options = get_option( 'stk_settings' ); 
        $tableoutput .= '<table class="form-table tablex"><tbody>
        	<tr valign="top">
				<th scope="row"><label>Enter the URL</label></th>
				<td><input type="text" placeholder="google.com" name="stk_text_field_url" id="stk_text_field_url" style="height:30px" class="regular-text" value="'.$options["stk_text_field_url"].'"></td>
			</tr>
            <div class="clear" style="width:100%;clear:both;"></div>
            <tr valign="top">
				<th scope="row"><label>Select Page</label></th>
                <td><select name="stk_pages" id="stk_pages">
                     <option value="" selected="selected" data-url="">--Select--</option>';
                     $pages = get_pages(); 
                        foreach ($pages as $page_data) {
                            $tableoutput .='<option value="'.$page_data->ID.'" data-url="'.get_page_link($page_data->ID).'">'.$page_data->post_title.'</option>';
                        }
                      $tableoutput .='</select>
                      </td>
			</tr>
            <tr valign="top">
				<th scope="row"><label>Select Post</label></th>
                <td> <select name="stk_posts" id="stk_posts">
                     <option value="" selected="selected" data-url="">--Select--</option>';
                     $posts = query_posts($query_string.'&cat=-9');; 
                        foreach ($posts as $posts_data) {
                            $tableoutput .='<option value="'.$posts_data->ID.'" data-url="'.get_page_link($posts_data->ID).'">'.$posts_data->post_title.'</option>';
                        }
                     
                  $tableoutput .='</select></td>
			</tr>
            <tr valign="top">
				<th scope="row">&nbsp;</th>
				<td><input type="submit"  style="display: inline-block;position: relative;" value="Create Report" class="button create_report button-primary" id="submit" name="submit"></td>
			</tr>
        </tbody></table>
       	</form>';
     echo $tableoutput;
	  
		$siteurl=$options['stk_text_field_url'];
if(!empty($siteurl)) {

echo '<table cellspacing="0px" cellpadding="10px" width="100%" class="BlueTable" style="border:1px solid #cccccc;background-color:#fafafa;margin:20px 20px 0 0;"> 		 		<tbody>
<tr class="HeadRow" style="background-color:#dbfbb1;">
	<td width="140" colspan="2" style="text-align: center;"><b style="color:#777777; font-size:20px;"> SEO ANALYSIS REPORT  - '.$siteurl.' </b></td> 			
</tr>
<tr class="Even">
  <td width="140"><b>Metrics</b></td> 			
		<td width="30"><b>Details</b></td>
	</tr>';


//*********  Google PageRank ***************				
$pr = new PR();
$sitedomain = stk_get_domain($siteurl);
echo '<tr class="Odd">
		<td width="140">Google Page Rank: </td> 			
		<td width="30"><b>'. ( $pr->get_google_pagerank($sitedomain) !='' ? $pr->get_google_pagerank($sitedomain) : '-').'</b></td>
	</tr>';

// **************** Alexa Rank ************************
 
 echo '<tr class="Even"><td width="140">Alexa Rank: </td><td width="30"><b>';

 $xml = simplexml_load_file('http://data.alexa.com/data?cli=10&dat=snbamz&url='.$siteurl);
 $rank=isset($xml->SD[1]->POPULARITY)?$xml->SD[1]->POPULARITY->attributes()->TEXT:0;
 $web=(string)$xml->SD[0]->attributes()->HOST;
 echo $rank;
 echo '</b></td></tr>';	
 
 
//************** Web Page Speed ****************	
  	$html = file_get_html(base64_decode('aHR0cDovL3d3dy5pd2VidG9vbC5jb20vdG9vbC90b29scy9zcGVlZF90ZXN0L3NwZWVkX3Rlc3QucGhwP2RvbWFpbj0=').$siteurl); 
	 foreach($html->find('table tr[3] td[4]') as $dT) {
			echo '<tr class="Even">
					<td width="140">Web Page Speed: </td> 			
					<td width="30"><b>'.$dT->innertext.'</b></td>
				</tr>';	
	 }
	
	
// ********************* title tag *****************

$html = stk_file_get_contents_curl($siteurl);

//parsing begins here:
$doc = new DOMDocument();
@$doc->loadHTML($html);
$nodes = $doc->getElementsByTagName('title');

$sitetitle = $nodes->item(0)->nodeValue;

$metas = $doc->getElementsByTagName('meta');

for ($i = 0; $i < $metas->length; $i++) {
    $meta = $metas->item($i);
    if($meta->getAttribute('name') == 'description')
        $description = $meta->getAttribute('content');
    if($meta->getAttribute('name') == 'keywords')
        $keywords = $meta->getAttribute('content');
}


 //-------------------
$imgs = $doc->getElementsByTagName('img');
for ($i = 0; $i < $imgs->length; $i++) {
    $img = $imgs->item($i);
    if($img->getAttribute('alt') != '')
        $imagesAlt = $img->getAttribute('alt'); 
	
	if($img->getAttribute('title') != '')
        $imagesTitle = $img->getAttribute('title'); 	
}

 

echo '<tr class="Odd"><td width="140">Title tag: </td><td width="30"><b>';
	  	
if(isset($sitetitle) && $sitetitle !='') {
	echo '<img src="' . plugins_url( 'images/yes.png', __FILE__ ) . '" alt="Yes"/> ';	
} else {
	echo '<img src="' . plugins_url( 'images/no.png', __FILE__ ) . '" alt="No" width="18"/> ';	
}
echo '</b></td></tr>';


//******************** 	Heading (H1) Tag **********************

$nodesH = $doc->getElementsByTagName('h1');

$headingTag = $nodesH->item(0)->nodeValue;	

echo '<tr class="Even"><td width="140">Heading (H1) Tag: </td><td width="30"><b>';
	
if(isset($headingTag) && $headingTag !='') {
	echo '<img src="' . plugins_url( 'images/yes.png', __FILE__ ) . '" alt="Yes"/> ';	
} else {
	echo '<img src="' . plugins_url( 'images/no.png', __FILE__ ) . '" alt="No" width="18"/> ';
}	
echo '</b></td></tr>';	
	
	
//******************** 	Meta Description tag **********************
	
echo '<tr class="Odd"><td width="140">Meta Description tag: </td><td width="30"><b>';
if(isset($description) && $description !='') {
	echo '<img src="' . plugins_url( 'images/yes.png', __FILE__ ) . '" alt="Yes"/> ';	
} else {
	echo '<img src="' . plugins_url( 'images/no.png', __FILE__ ) . '" alt="No" width="18"/> ';
}
echo '</b></td></tr>';	
	


//****************** Meta Keywords tag ************************
echo '<tr class="Even"><td width="140">Meta Keywords tag: </td><td width="30"><b>';
if(isset($keywords) && $keywords !='') {
	echo '<img src="' . plugins_url( 'images/yes.png', __FILE__ ) . '" alt="Yes"/> ';	
} else {
	echo '<img src="' . plugins_url( 'images/no.png', __FILE__ ) . '" alt="No" width="18"/> ';
}
echo '</b></td></tr>';	



//****************** Image ALT tags ************************
echo '<tr class="Odd"><td width="140">Image ALT tags: </td><td width="30"><b>';
if(isset($imagesAlt) && $imagesAlt !='') {
	echo '<img src="' . plugins_url( 'images/yes.png', __FILE__ ) . '" alt="Yes"/> ';	
} else {
	echo '<img src="' . plugins_url( 'images/no.png', __FILE__ ) . '" alt="No" width="18"/> ';
}
echo '</b></td></tr>';	




// **************** Image Title tags ************************
echo '<tr class="Even"><td width="140">Image Title tags: </td><td width="30"><b>';
if(isset($imagesTitle) && $imagesTitle !='') {
	echo '<img src="' . plugins_url( 'images/yes.png', __FILE__ ) . '" alt="Yes"/> ';	
} else {
	echo '<img src="' . plugins_url( 'images/no.png', __FILE__ ) . '" alt="No" width="18"/> ';
}
echo '</b></td></tr>';	



// **************** Robots.txt ************************

echo '<tr class="Odd"><td width="140">Robots.txt: </td><td width="30"><b>';
$info = parse_url($siteurl);
$host = $info['host'];
$file_headers = @get_headers($host.'/robots.txt');
if($file_headers[0] == 'HTTP/1.1 404 Not Found') {
    echo 'Not Found';    
}
else {
    echo 'Found';
}
echo '</b></td></tr>';	

 // **************** Total Backlinks************************
 
 echo '<tr class="Odd"><td width="140">Total Backlinks: </td><td width="30"><b>';

 $xml = simplexml_load_file('http://data.alexa.com/data?cli=10&dat=snbamz&url='.$siteurl);
 $totalBacklinks=isset($xml->SD[0]->LINKSIN)?$xml->SD[0]->LINKSIN->attributes()->NUM:0;
 echo $totalBacklinks;
 echo '</b></td></tr>';	



// **************** Outbound Links  ************************

    $url = $siteurl;
    $linksInArray = stk_get_a_href($url);
    $CountOfExternalLink = count($linksInArray['ExternalLinks']);
    $CountOfInternalLink = count($linksInArray['InternalLinks']);

echo '<tr class="Even"><td width="140">Outbound Links: </td><td width="30"><b>';
	if(!empty($linksInArray['ExternalLinks'])){
			echo $CountOfExternalLink;
	} else{
    	echo 0;
    }
echo '</b></td></tr>';	
	
	
// **************** Inbound Links  ************************
	
echo '<tr class="Odd"><td width="140">Inbound Links: </td><td width="30"><b>';

    if(!empty($linksInArray['InternalLinks'])){
		echo $CountOfInternalLink;
    } else{
    	echo 0;
    }
echo '</b></td></tr>';	
  
 echo '</tbody></table>';

}
}
?>